// FILE. . . . . /home/hak/hlt/src/hlt/osfv2/base/OrSortExpression.java
// EDIT BY . . . Hassan Ait-Kaci
// ON MACHINE. . Hak-Laptop
// STARTED ON. . Mon Sep 02 09:15:40 2013

/**
 * @version     Last modified on Tue Jan 21 08:05:52 2014 by hak
 * @author      <a href="mailto:hak@acm.org">Hassan A&iuml;t-Kaci</a>
 * @copyright   &copy; <a href="http://www.hassan-ait-kaci.net/">by the author</a>
 */

package hlt.osf.base;

/**
 * This is the class of an 'or' sort expression. It consists of two
 * SortExpression which are its arguments.
 */
public class OrSortExpression extends BinarySortExpression
  {
    public OrSortExpression (SortExpression lhs, SortExpression rhs)
    {
      super(lhs,rhs);
      _context = lhs.context();
    }

    public byte type ()
    {
      return _context.OR();
    }

    public String displayForm ()
    {
      String form = _lhs.displayForm() + " | " + _rhs.displayForm();
      return isParenthesized() ? "("+form+")" : form;
    }

    public boolean equals (Object other)
    {
      if (!(other instanceof OrSortExpression))
	return false;

      OrSortExpression o = (OrSortExpression)other;
      
      return _lhs.equals(o.lhs()) && _rhs.equals(o.rhs())
          || _rhs.equals(o.rhs()) && _lhs.equals(o.lhs());
    }

  }
